<?php
/**
 * @package	HikaShop for Joomla!
 * @version	4.7.1
 * @author	hikashop.com
 * @copyright	(C) 2010-2023 HIKARI SOFTWARE. All rights reserved.
 * @license	GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
$button_style = 'style="height: 30px;width: 130px;"';
$config = hikashop_config();
$delay = (int)$config->get('switcher_cookie_retaining_period', 31557600);
$notice = JText::_( 'HIKA_NOTICE_COLUMNS' );
?>
<!-- Dropdown columns selector -->
<div class="hkdropdown column_container">	
	<button type="button" data-toggle="hkdropdown" class="btn btn-primary button_column" aria-haspopup="true" aria-expanded="false" <?php echo $button_style; ?>>
		<span class="column_number"></span>
		<span class="columns_separator"> / </span>
		<span class="column_number_total"></span>
		<span class="hkdropdown-text column_text" style="margin: 0 5px;">
			<?php echo JText::_( 'HIKA_SELECT_COLUMNS' ); ?>
		</span>
		<span class="caret"></span>
	</button>
	<!-- Dropdown columns settings [fill by JS] -->
	<ul class="hika_columns_select hkdropdown-menu"></ul>
</div>

<script type="text/javascript">
if(!window.localPage) window.localPage = {};

function dropdownFill () {
	var elems = document.querySelectorAll('table.adminlist .title');
	var elems_nb = elems.length;

	var drop_html ='';
	var ref = 1;
	var def_nb = 0;
	var unDisplayed = 0

	const header_name = [];
	var def_str = '';
	for (i = 0; i < elems_nb; i++) {
		var status = 'checked';
		if (elems[i].classList.contains('default')) {
			var alias = elems[i].getAttribute('data-alias');
			def_str += '/'+alias+':'+ref;
			status = '';
			def_nb++;
		}
		header_name[i] = elems[i].textContent.trim();
		if(header_name[i] == '') {
			ref++;
			unDisplayed++;
			continue;
		}
		drop_html += '<li>'+
			'<label href="#" onclick="window.localPage.actionColumns(event, ' + ref + ', \'click\'); return false;">' +
				'<input class="form-check-input me-1" id="columnSelect_' + ref + '" type="checkbox" name="columnSelect" value="' + header_name[i] + '" '+status+'>' +
				'<span class="hika_columns_name">' + header_name[i] + '</span>' +
			'</label>'+
		'</li>';

		extra_def = '';
		ref++;
	}
	var container = document.querySelector('.hika_columns_select');
	container.innerHTML = drop_html;

	if (def_str != '')
		manageDef(def_str);
	updateNumbers(elems_nb-def_nb,elems_nb - unDisplayed,'');
}

function manageDef(def_str) {
	var cookies = cookiesCheck();
	let def_array = def_str.split('/');
	for (let i = 0; i < def_array.length; i++) { 
		if( def_array[i] == '' ) continue;

		let final_array = def_array[i].split(':');
		var default_ref = final_array[1];

		cssProcess(default_ref,'hide');
		classOperation(default_ref,'hide');
	}
	var new_cookies = '';
	var tot_cookies = '';
	if (cookies != '') {
		let cookiesVal = cookies.split('/');
		for(let i = 0; i <cookiesVal.length; i++) {
			var drift = 0;
			var added = false;

			if (cookiesVal[i].includes('_')) {
				tot_cookies = cookiesVal[i].slice(4,6);
				continue;
			}
			if(cookiesVal[i].includes('d=')) {
				let cookies_def_array = cookiesVal[i].split(':');
				var cookies_ref = cookies_def_array[1];
				var cookies_alias = cookies_def_array[0].slice(2,cookies_def_array[0].length);
				if(def_str.includes('/d='+cookies_alias+':')) {
					for (let ic = 1; ic <def_array.length; ic++) {
						if( def_array[ic] == '' ) continue;

						let final_array = def_array[ic].split(':');
						var default_ref = final_array[1];
						var default_alias = final_array[0].slice(2,cookies_def_array[0].length);

						if (cookies_alias == default_alias && cookies_ref != default_ref) {
							new_cookies += '/d='+default_alias+':'+default_ref;
							drift++;
							added = true;
							continue;
						}
						if (default_alias == cookies_alias && default_ref == cookies_ref) {
							new_cookies += '/d='+cookies_alias+':'+cookies_ref;
							added = true;
							continue;
						}
					}	
				}
				cookies_ref = parseInt(cookies_ref) + drift
				new_cookies += '/d='+cookies_alias+':'+ cookies_ref;
			}
			else {
				cookiesVal[i] = parseInt(cookiesVal[i]) + drift
				new_cookies += '/' + cookiesVal[i];
				continue;
			}
		}
		var new_tot = parseInt(tot_cookies) + drift;
		new_tot = 'tot_' + new_tot;

		var new_cookies_str = new_tot + new_cookies;
		var list_code = getListKey();
		window.hikashop.setCookie("cookie_" + list_code,new_cookies_str,<?php echo $delay; ?>);
	}
}
window.localPage.actionColumns = function (event, rank, action) {
	if (event != '') {
		event = event || window.event;
		event.preventDefault();
		event.stopPropagation();
	}
	cssProcess(rank,action);

	checkboxOperation(rank,action);

	var operator = classOperation(rank,action);

	var elems = document.querySelectorAll('table.adminlist .title');
	var elems_nb = elems.length;

	var unDisplayed = 0;
	for (i = 0; i < elems_nb; i++) {
		if(elems[i].textContent.trim() == '')
			unDisplayed++;
	}
	elems_nb = elems_nb - unDisplayed;

	updateNumbers('','',operator);

	if (action == 'click')
		cookiesSave(rank, elems_nb);
}
function cookiesCheck() {
	var list_code = getListKey();

	let name = "cookie_" + list_code + "=";
	let decodedCookie = decodeURIComponent(document.cookie);
	let cookiesAll = decodedCookie.split(';');

	for(let i = 0; i <cookiesAll.length; i++) {
		let cookie = cookiesAll[i];
		while (cookie.charAt(0) == ' ') {
		  cookie = cookie.substring(1);
		}
		if (cookie.indexOf(name) == 0) {
			return cookie.substring(name.length, cookie.length);
		}
	}
	return "";
}
function order_columns_notice() {
	var errormsg = '<?php echo $notice; ?>';

	Joomla.renderMessages({"warning":[errormsg]});
}
function getListKey() {
	var elems = document.querySelector('#hikashop_main_content form table.adminlist');
	var table_id = elems.id;

	var list_code = table_id.substring(9, 12);

	let name_array = table_id. split("_");
	var list_code = name_array[1];

	if (list_code == 'plugins') {
		var form_elem = document.querySelector('#hikashop_main_content form');
		var form_action = form_elem.action;
		let plg_type_array = form_action. split("=");
		list_code = plg_type_array[3];
	}
	return list_code;
}
function cssProcess (rank, action) {
	var css_value_hide = 'display:none;';
	var css_value_hidden = 'display:table-cell;';

	var css_hide = 'table.adminlist tbody td:nth-child(' + rank + '), ' +
	'table.adminlist thead th:nth-child(' + rank + ') {' + css_value_hide + '}';
	var css_unhidden = 'table.adminlist tbody td:nth-child(' + rank + '), ' +
	'table.adminlist thead th:nth-child(' + rank + ') {' + css_value_hidden + '}';

    head = document.head || document.getElementsByTagName('head')[0],
    style = document.createElement('style');
	head.appendChild(style);

	var css = '';
	var elems = document.querySelectorAll('table.adminlist .title');
	var elems_targeted = elems[parseInt(rank) - 1];

	if (action == 'hide')
		css = css_hide;

	if (action == 'display')
		css = css_unhidden;

	if (action == 'click') {
		if(elems_targeted.classList.contains('columns_hide')) {
			css = css_unhidden;
		}
		else {
			css = css_hide;
		}
	}

	style.type = 'text/css';
	if (style.styleSheet) {
		style.styleSheet.cssText = css;
	} else {
		style.appendChild(document.createTextNode(css));
	}
}
function checkboxOperation(rank,action) {
	var string = '';

	var elems = document.querySelectorAll('table.adminlist .title');
	var checkbox = document.getElementById('columnSelect_' + rank);
	var elems_targeted = elems[parseInt(rank) - 1];
	var status = '';
	if(action == 'hide')
		status = false;
	if(action == 'display') {
		status = true;
	}
	if(action == 'click') {
		if (elems_targeted.classList.contains('columns_hide'))
			status = true;
		else 
			status = false;
	}
	checkbox.checked = status;
}
function classOperation(rank,action) {

	var operator = '';
	var elems = document.querySelectorAll('table.adminlist .title');
	var elems_targeted = elems[parseInt(rank) - 1];

	if(action == 'hide') {
		if(!elems_targeted.classList.contains('columns_hide'))
			elems_targeted.classList.add('columns_hide');
		operator = '-';
	}
	if(action == 'display') {
		if(elems_targeted.classList.contains('columns_hide'))
			elems_targeted.classList.remove('columns_hide');

		operator = '+';
	}
	if(action == 'click') {
		if(elems_targeted.classList.contains('columns_hide')) {
			elems_targeted.classList.remove('columns_hide');
			operator = '+';
		}
		else {
			elems_targeted.classList.add('columns_hide');
			operator = '-';
		}
	}
	return operator;
}
function updateNumbers (nb,nb_tot,operation) {
	var number_tot = document.querySelector('.column_number_total');
	var number = document.querySelector('.column_number');

	if (nb == '' || nb_tot == '') {
		var nb_str_tot = number_tot.textContent;
		var nb_str = number.textContent;

		nb_tot = parseInt(nb_str_tot);
		nb = parseInt(nb_str);
	}
	if (operation == '-') {nb = nb - 1;}
	if (operation == '+') {nb = nb + 1;}

	number_tot.innerHTML = nb_tot;
	number.innerHTML = nb;
}
function cookiesSave(rank, columnTot) {
	var rank_ref = parseInt(rank);
	var nb_tot = 'tot_' + columnTot;
	var rank_alias = '';
	var elems = document.querySelectorAll('table.adminlist .title');
	if (elems[rank_ref - 1].classList.contains('default'))
		var rank_alias = 'd='+elems[parseInt(rank_ref)-1].getAttribute('data-alias');
	var old_columnRanks = cookiesCheck();
	var new_cookies = '';
	if (old_columnRanks != '') {
		var drift = 0;
		var new_cookies_str = '';
		let old_cookies_array = old_columnRanks.split('/');

		for(let i = 0; i < old_cookies_array.length; i++) {
			if (old_cookies_array[i] == '' || old_cookies_array[i].includes('_'))
				continue;
			var cookies_ref = parseInt(old_cookies_array[i]);
			var cookies_alias = '';	

			if (old_cookies_array[i].includes('d=')) {
				let cookies_def_array = old_cookies_array[i].split(':');
				cookies_ref = parseInt(cookies_def_array[1]);
				cookies_alias = cookies_def_array[0];
			}
			else 
				cookies_ref = parseInt(old_cookies_array[i]);
			if (cookies_ref == rank_ref) {
				if (cookies_alias == rank_alias) {
					rank_ref = '';
					rank_alias = '';
					continue;
				}
				else {
					if (cookies_alias != '' && rank_alias != '') {
						elem_default = document.querySelectorAll('table.adminlist .default');
						for (let ie; ie < elem_default.length; ie++) {
							if (elem_default[ie].getAttribute('data-alias') == rank_alias.slice(2,rank_alias.length)) {
								cookies_ref = parseInt(ie) + 1;
								break;
							}
						}
						rank_ref = rank_alias + ':' + rank_ref + '/' + cookies_alias + ':' + cookies_ref;
						drift = 1;
						continue;
					}
					if (cookies_alias == '' && rank_alias != '') {
						rank_ref = rank_alias + ':' + rank_ref + '/' + cookies_ref +1;
						drift = 1;
						continue;
					}
					if (cookies_alias != '' && rank_alias == '') {
						rank_ref = rank_ref + '/' + cookies_alias + ':' + cookies_ref + 1;
						drift = 1;
						continue;
					}
				}
			}
			else {
				if (cookies_alias == rank_alias && rank_alias != '') {
					rank_ref = rank_alias + ':' + rank_ref;
					continue;
				}
			}
			cookies_ref = parseInt(cookies_ref) + drift;

			if (cookies_alias != '')
				new_cookies_str += '/'+cookies_alias+':'+cookies_ref;
			else
				new_cookies_str += '/'+cookies_ref;
		}
		if (rank_alias != '')
			rank_ref = rank_alias + ':' + rank_ref;

		new_cookies = nb_tot + new_cookies_str + '/' + rank_ref;
	}
	else {
		if (rank_alias != '')
			rank_ref = rank_alias + ':' + rank_ref;

		new_cookies = nb_tot + '/' + rank_ref;
	}
	var list_code = getListKey();
	window.hikashop.setCookie("cookie_" + list_code,new_cookies,<?php echo $delay; ?>);
}
function afterDisplay() {
	var elems = document.querySelectorAll('table.adminlist .title');
	var unDisplayed = 0;
	var uncheckedNb = 0;
	var checkedNb = 0;

	for (i = 0; i < elems.length; i++) {
		if(elems[i].textContent.trim() == '')
			unDisplayed++;
		if (elems[i].classList.contains('default'))
			uncheckedNb++
	}
	var elems_nb = elems.length - unDisplayed;

	let fromCookie =  cookiesCheck();
	if (fromCookie != '') {
		let cookiesAll = fromCookie.split('/');
		for(let i = 0; i <cookiesAll.length; i++) {
			if (cookiesAll[i] == '')
				continue;

			if (cookiesAll[i].includes('_')) {
				if (cookiesAll[i] != 'tot_' + elems_nb)
					order_columns_notice('');

				continue;
			}

			if (cookiesAll[i].includes('d=')) {
				let cookies_def_array = cookiesAll[i].split(':');
				var cookies_ref = cookies_def_array[1];

				window.localPage.actionColumns('',cookies_ref,'display');

				checkedNb++;

				continue;
			}
			else {
				window.localPage.actionColumns('',cookiesAll[i],'hide');

				uncheckedNb++;
			}
		}
	}
	checkedNb = elems_nb - uncheckedNb + checkedNb;
	updateNumbers(checkedNb, elems_nb, '');
}
window.hikashop.ready(function(){
	dropdownFill();
	setTimeout(function(){afterDisplay();}, 100);
});
</script>
